//-----------------------------------------------------
//-------  Parameter-less SGA		            -------
//-------  - Individual's functions				-------
//-----------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <time.h>
#include <string.h>
#include <float.h>
//----------------
#include "general.h"
#include "individual.h"

//------- Fitness function definitions
#define TRAP
//#define ONEMAX
//#define TWOPOINT
#define UNIFORM


//----------------------------------------------------------------------
//------- Fitness Function calculation
//-------  - onemax problem
# ifdef ONEMAX
void get_fitness(tind *individual){
	int i;

	//------- 
	(*individual).fitness = 0.0;
	for(i=0; i<maxGenes; i++)
		if((*individual).genes[i] == 1)
			(*individual).fitness += 1.0;
}
# endif

//----------------------------------------------------------------------
//------- Fitness Function calculation
//-------  - Problem composed of 4-bit trap functions.
# ifdef TRAP
void get_fitness(tind *individual){
	int i, j;
	int u;

	//------- 
	(*individual).fitness = 0.0;
	i = 0;
	while((i+3) < maxGenes){
		u = 0;
		for(j=0; j<4; j++)
			if((*individual).genes[i+j] == 1)
				u++;
		//---
		if(u < 4)
			(*individual).fitness += (double)(3 - u);
		else
			(*individual).fitness += (double)4;
		//---
		i = i + 4;
	}
}
# endif

//----------------------------------------------------------------------
//------- crossover - 2-point
# ifdef TWOPOINT
void crossover(int *parent1, int *parent2, int *child1, int *child2){
	int i;
	int lp,rp,pom;

	//------- choose two crossing points - left and right
	lp = rand()%maxGenes;
	do rp = (rand()%maxGenes); while(lp==rp);
	if(lp>rp){
		pom=lp;
		lp=rp;
		rp=pom;
	}

	//------- head section
	for(i=0; i<lp; i++){
		child1[i] = parent1[i];
		child2[i] = parent2[i];
	}

	//------- middle section
	for(i=lp; i<rp; i++){
		child2[i] = parent1[i];
		child1[i] = parent2[i];
	}

	//------- end section
	for(i=rp; i<maxGenes; i++){
		child1[i] = parent1[i];
		child2[i] = parent2[i];
	}
}
#endif 

//----------------------------------------------------------------------
//------- crossover - uniform
# ifdef UNIFORM
void crossover(int *parent1, int *parent2, int *child1, int *child2){
	int i;
	int lp,rp,pom;

	for(i=0; i<maxGenes; i++)
		if(rand()%2){
			child1[i] = parent1[i];
			child2[i] = parent2[i];
		}
		else{
			child1[i] = parent2[i];
			child2[i] = parent1[i];
		}
}
#endif

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//------- Mutation - simple bit-flip mutation
void mutation(int *chromosome){
	int i;

	//------- Applies mutation to every gene with probability Pm
	for(i=0; i<maxGenes; i++)
		if(rand()%100 < pMutation)
			chromosome[i] = (chromosome[i] + 1) % 2;	//--- changes 1->0 and 0->1
}

